#!/bin/sh

cfgnam=$1
parnam=$2
parold=$3
parnew=$4
logfile=valchanged.log
interfaces=/etc/network/interfaces
mrsystem=/etc/mrsystem

to_static() {
	address=`fgrep linux-ipaddress linux.cfg | cut -f 2 -d '"'`
	netmask=`fgrep linux-netmask linux.cfg | cut -f 2 -d '"'`
	network=`fgrep linux-network linux.cfg | cut -f 2 -d '"'`
	gateway=`fgrep linux-gateway linux.cfg | cut -f 2 -d '"'`
	sudo sed -i \
		-e 's;^# *\(iface eth0 inet static\);\1;' \
		-e "s;^# *\(address $address\);\1;" \
		-e "s;^# *\(netmask $netmask\);\1;" \
		-e "s;^# *\(network $network\);\1;" \
		-e "s;^# *\(gateway $gateway\);\1;" \
		-e 's;^\(iface eth0 inet dhcp\);# \1;' $interfaces
}

to_dhcp() {
	address=`fgrep linux-ipaddress linux.cfg | cut -f 2 -d '"'`
	netmask=`fgrep linux-netmask linux.cfg | cut -f 2 -d '"'`
	network=`fgrep linux-network linux.cfg | cut -f 2 -d '"'`
	gateway=`fgrep linux-gateway linux.cfg | cut -f 2 -d '"'`
	sudo sed -i \
		-e 's;^\(iface eth0 inet static\);# \1;' \
		-e "s;^ *\(address $address\);#\1;" \
		-e "s;^ *\(netmask $netmask\);#\1;" \
		-e "s;^ *\(network $network\);#\1;" \
		-e "s;^ *\(gateway $gateway\);#\1;" \
		-e 's;^# *\(iface eth0 inet dhcp\);\1;' $interfaces
}

chg_calue() {
	sudo sed -i \
		-e "s;^ *\($1 $2\);$1 $3;" \
		-e "s;^# *\($1 $2\);#$1 $3;" $interfaces
}

chg_int_mrsystem() {
	sudo sed -i -e "s;^\($1 $2\);$1 $3;" $mrsystem
}

chg_txt_mrsystem() {
	sudo sed -i \
		-e "s;^\($1 \"$2\"\);$1 \"$3\";" $mrsystem
}

if [ $cfgnam = "sysconfig" ] ; then
	echo "evaluate sysconf" >> /tmp/uci.log
	if [ $parnam = "linux-dhcp" ] ; then
		if [ $parnew = "off" ] ; then
			to_static
		elif [ $parnew = "on" ] ; then
			to_dhcp
		fi
	elif [ $parnam = "linux-ipadress" ] ; then
		chg_calue address $parold $parnew
	elif [ $parnam = "linux-netmask" ] ; then
		chg_calue netmask $parold $parnew
	elif [ $parnam = "linux-network" ] ; then
		chg_calue network $parold $parnew
	elif [ $parnam = "linux-gateway" ] ; then
		chg_calue gateway $parold $parnew
	elif [ $parnam = "zentrale" ] ; then
		echo "zentrale changed" >> /tmp/uci.log
		chg_int_mrsystem zentrale $parold $parnew
	elif [ $parnam = "broadcast" ] ; then
		if [ $parold = "off" ] ; then
			if [ $parnew = "off" ] ; then
				to_static
				chg_int_mrsystem broadcast 0 0
			elif [ $parnew = "on" ] ; then
				chg_int_mrsystem broadcast 0 1
			fi
			elif [ $parold = "on" ] ; then
			if [ $parnew = "off" ] ; then
				chg_int_mrsystem broadcast 1 0
			elif [ $parnew = "on" ] ; then
				chg_int_mrsystem broadcast 1 1
			fi
		fi
	elif [ $parnam = "udpbc" ] ; then
		chg_int_mrsystem udpbc $parold $parnew
	elif [ $parnam = "address" ] ; then
		chg_txt_mrsystem address $parold $parnew
	elif [ $parnam = "port" ] ; then
		chg_int_mrsystem port $parold $parnew
	elif [ $parnam = "interface" ] ; then
		chg_txt_mrsystem interface $parold $parnew
	elif [ $parnam = "can_interface" ] ; then
		chg_txt_mrsystem can_interface $parold $parnew
	elif [ $parnam = "cs2_path" ] ; then
		chg_txt_mrsystem cs2_path $parold $parnew
	elif [ $parnam = "reboot" ] ; then
		chg_txt_mrsystem cs2_path $parold $parnew
		if [ $parnew = "System" ] ; then
			sudo /sbin/reboot
		elif [ $parnew = "MRSystem" ] ; then
			sudo /etc/init.d/mrsystem restart
		elif [ $parnew = "Anhalten" ] ; then
			sudo /sbin//halt
		fi
	fi
fi
